<?php # $Id: serendipity_event_geotag.php,v 1.25 2007/08/16 13:44:14 garvinhicking Exp $

// Zoran Kovacevic http://www.kovacevic.nl/blog
// Shameless copy of serendipity_event_entryproperties and serendipity_event_multilingual


if (IN_serendipity !== true) {
    die ("Don't hack!");
}

// Probe for a language include with constants. Still include defines later on, if some constants were missing
$probelang = dirname(__FILE__) . '/' . $serendipity['charset'] . 'lang_' . $serendipity['lang'] . '.inc.php';
if (file_exists($probelang)) {
    include $probelang;
}

include_once dirname(__FILE__) . '/lang_en.inc.php';

class serendipity_event_geotag extends serendipity_event
{
    var $services;
    var $title = PLUGIN_EVENT_GEOTAG_TITLE;

    function introspect(&$propbag)
    {
        global $serendipity;

        $propbag->add('name',          PLUGIN_EVENT_GEOTAG_TITLE);
        $propbag->add('description',   PLUGIN_EVENT_GEOTAG_DESC);
        $propbag->add('stackable',     false);
        $propbag->add('author',        'Zoran Kovacevic');
        $propbag->add('version',       '1.20');
        $propbag->add('requirements',  array(
            'serendipity' => '0.8',
            'smarty'      => '2.6.7',
            'php'         => '4.1.0'
        ));
        $propbag->add('event_hooks',    array(
            'backend_publish'                                   => true,
            'backend_save'                                      => true,
            'backend_display'                                   => true,
            'css'                                               => true,
            'entry_display'                                     => true,
            'frontend_entryproperties'                          => true,
            'frontend_entryproperties_query'                    => true,
            'frontend_fetchentries'                             => true,
            'frontend_fetchentry'                               => true,
            'frontend_display:rss-2.0:namespace'                => true,
            'frontend_display:rss-2.0:per_entry'                => true
        ));

        $propbag->add('groups',                 array('BACKEND_EDITOR'));
        $propbag->add('configuration', array('map_url','api_key','init_latitude','init_longitude','zoom'));
        $this->supported_properties = array('geo_long', 'geo_lat');
    }

    function introspect_config_item($name, &$propbag)
    {
        switch($name) {
            case 'map_url':
                $propbag->add('type',        'string');
                $propbag->add('name',        PLUGIN_EVENT_GEOTAG_MAP_URL);
                $propbag->add('description', PLUGIN_EVENT_GEOTAG_MAP_DESC);
		        $propbag->add('default',     'http://local.google.com/maps?q=%GEO_LAT%,%GEO_LONG%+(%TITLE%)&amp;spn=0.1,0.1&amp;t=h');
                break;
			case 'api_key':
                $propbag->add('type',        'string');
                $propbag->add('name',        PLUGIN_EVENT_GEOTAG_API_KEY);
                $propbag->add('description', PLUGIN_EVENT_GEOTAG_API_KEY_DESC);
				break;
			case 'init_latitude':
                $propbag->add('type',        'string');
                $propbag->add('name',        PLUGIN_EVENT_GEOTAG_LAT);
                $propbag->add('description', PLUGIN_EVENT_GEOTAG_LAT_DESC);
				break;
			case 'init_longitude':
                $propbag->add('type',        'string');
                $propbag->add('name',        PLUGIN_EVENT_GEOTAG_LONG);
                $propbag->add('description', PLUGIN_EVENT_GEOTAG_LONG_DESC);
				break;
			case 'zoom':
                $propbag->add('type',        'string');
                $propbag->add('name',        PLUGIN_EVENT_GEOTAG_ZOOM);
                $propbag->add('description', PLUGIN_EVENT_GEOTAG_ZOOM_DESC);
				break;
        }
        return true;
    }

    function generate_content(&$title) {
        $title = $this->title;
    }

    function addProperties(&$properties, &$eventData) {
        global $serendipity;
        // Get existing data
        $property = serendipity_fetchEntryProperties($eventData['id']);

        foreach($this->supported_properties AS $prop_key) {
            $prop_val = (isset($properties[$prop_key]) ? $properties[$prop_key] : null);
            $prop_key = 'ep_' . $prop_key;
            if (!isset($property[$prop_key]) && !empty($prop_val)) {
                $q = "INSERT INTO {$serendipity['dbPrefix']}entryproperties (entryid, property, value) VALUES (" . (int)$eventData['id'] . ", '" . serendipity_db_escape_string($prop_key) . "', '" . serendipity_db_escape_string($prop_val) . "')";
            } elseif ($property[$prop_key] != $prop_val && !empty($prop_val)) {
                $q = "UPDATE {$serendipity['dbPrefix']}entryproperties SET value = '" . serendipity_db_escape_string($prop_val) . "' WHERE entryid = " . (int)$eventData['id'] . " AND property = '" . serendipity_db_escape_string($prop_key) . "'";
            } else {
                $q = "DELETE FROM {$serendipity['dbPrefix']}entryproperties WHERE entryid = " . (int)$eventData['id'] . " AND property = '" . serendipity_db_escape_string($prop_key) . "'";
            }

            serendipity_db_query($q);
        }
    }

    function event_hook($event, &$bag, &$eventData, $addData = null) {
        global $serendipity;

        $hooks = &$bag->get('event_hooks');
        $is_cache = serendipity_db_bool($this->get_config('cache', 'true'));
        if (isset($hooks[$event])) {
            switch($event) {
                case 'backend_display':
                    if (isset($eventData['properties']['geo_long'])) {
                        $geo_long = $eventData['properties']['geo_long'];
                    } elseif (isset($serendipity['POST']['properties']['geo_long'])) {
                        $geo_long = $serendipity['POST']['properties']['geo_long'];
                    } else {
                        $geo_long = "";
                    }
                    if (isset($eventData['properties']['geo_lat'])) {
                        $geo_lat = $eventData['properties']['geo_lat'];
                    } elseif (isset($serendipity['POST']['properties']['geo_lat'])) {
                        $geo_lat = $serendipity['POST']['properties']['geo_lat'];
                    } else {
                        $geo_lat = "";
                    }
?>
                    <fieldset style="margin: 5px">
                        <legend><?php echo PLUGIN_EVENT_GEOTAG_TITLE; ?></legend>
                            <input class="input_textbox" type="text" name="serendipity[properties][geo_lat]" id="properties_geo_lat" value="<?php echo $geo_lat ?>" />
                            <label title="<?php echo PLUGIN_EVENT_GEOTAG_LAT; ?>" for="properties_geo_lat">&nbsp;<?php echo PLUGIN_EVENT_GEOTAG_LAT; ?>&nbsp;&nbsp;</label>
                            <input class="input_textbox" type="text" name="serendipity[properties][geo_long]" id="properties_geo_long" value="<?php echo $geo_long ?>" />
                            <label title="<?php echo PLUGIN_EVENT_GEOTAG_LONG; ?>" for="properties_geo_long">&nbsp;<?php echo PLUGIN_EVENT_GEOTAG_LONG; ?>&nbsp;&nbsp;</label><p /><?php
					if (($this->get_config('api_key'))!="") {
							?>
							<div id="locationpicker" style="width: 600px; height: 350px"></div>
							<script src="http://maps.google.com/maps?file=api&amp;v=2&amp;key=<?php echo $this->get_config('api_key') ?>" type="text/javascript"></script>
							<script type="text/javascript">
							//<![CDATA[

								function GLocationPicker(
                                		pickerDivId,
                                		latitudeFieldId,
                                		longitudeFieldId,
                                		initLatitude,
                                		initLongitude,
                                		initZoom
                                		) {


									var map = new GMap2(document.getElementById(pickerDivId));
									var initPoint = new GLatLng(initLatitude, initLongitude);
									map.addControl(new GSmallMapControl());
									map.addControl(new GMapTypeControl());
									map.setCenter(initPoint, initZoom);
									map.addOverlay(new GMarker(initPoint));

                                	GEvent.addListener(map, "click", function(overlay, point) {
                                		document.getElementById(latitudeFieldId).value = point.y.toFixed(5);
                                		document.getElementById(longitudeFieldId).value = point.x.toFixed(5);
										map.clearOverlays();
										map.addOverlay(new GMarker(point));
                                	});
                                }

								// References to DOM elements to use
								var pickerDivId = "locationpicker";
								var latitudeFieldId = "properties_geo_lat";
								var longitudeFieldId = "properties_geo_long";

								// Startup parameters
								var initLatitude = document.getElementById(latitudeFieldId).value;
								if (initLatitude == 0) initLatitude = <?echo $this->get_config('init_latitude');?>;								
								var initLongitude = document.getElementById(longitudeFieldId).value
								if (initLongitude == 0) initLongitude = <?echo $this->get_config('init_longitude');?>;								
								var initZoom = <?echo $this->get_config('zoom');?>;

								GLocationPicker(
									pickerDivId,
									latitudeFieldId,
									longitudeFieldId,
									initLatitude,
									initLongitude,
									initZoom
									);

							//]]>
							</script>
							<?php
						}
							?>
						</fieldset>
<?php
                    return true;

                case 'backend_publish':
                case 'backend_save':
                    // Get existing data
                    $property = serendipity_fetchEntryProperties($eventData['id']);

                    // Insert POST values in database or update if it exists
                    foreach($this->supported_properties AS $prop_key) {
                        $prop_val = (isset($serendipity['POST']['properties'][$prop_key]) ? $serendipity['POST']['properties'][$prop_key] : null);
                        if (!isset($property[$prop_key]) && !empty($prop_val)) {
                            $q = "INSERT INTO {$serendipity['dbPrefix']}entryproperties (entryid, property, value) VALUES (" . (int)$eventData['id'] . ", '" . serendipity_db_escape_string($prop_key) . "', '" . serendipity_db_escape_string($prop_val) . "')";
                        } elseif (!empty($prop_val)) {
                            $q = "UPDATE {$serendipity['dbPrefix']}entryproperties SET value = '" . serendipity_db_escape_string($prop_val) . "' WHERE entryid = " . (int)$eventData['id'] . " AND property = '" . serendipity_db_escape_string($prop_key) . "'";
                        } else {
                            $q = "DELETE FROM {$serendipity['dbPrefix']}entryproperties WHERE entryid = " . (int)$eventData['id'] . " AND property = '" . serendipity_db_escape_string($prop_key) . "'";
                        }
                        serendipity_db_query($q);
                    }

                    return true;

                case 'frontend_entryproperties':
                    $q = "SELECT entryid, property, value FROM {$serendipity['dbPrefix']}entryproperties WHERE entryid IN (" . implode(', ', array_keys($addData)) . ")";

                    $properties = serendipity_db_query($q);

                    if (!is_array($properties)) {
                        return true;
                    }

                    foreach($properties AS $idx => $row) {
                        $eventData[$addData[$row['entryid']]]['properties'][$row['property']] = $row['value'];
                    }

                    return true;

                case 'css':
                    if (strpos($eventData, '.serendipity_geotag')) {
                        // class exists in CSS, so a user has customized it and we don't need default
                        return true;
                    }
?>

.serendipity_geotag {
    margin-left: auto;
    margin-right: 0px;
    text-align: right;
    font-size: 7pt;
    display: block;
    margin-top: 5px;
    margin-bottom: 0px;
}

.serendipity_geotag a {
    font-size: 7pt;
    text-decoration: none;
}

.serendipity_geotag a:hover {
    color: green;
}
<?php
                    return true;

                case 'entry_display':
                	// used for looping (seems unnecessary, since we use the foreach ...)
					if (isset($eventData) && is_array($eventData)) {
    					$i = 0;
                    	foreach($eventData as $event) {
    	                    // Check if geo_lat and geo_long are both set
    	                    $props = $eventData[$i]['properties'];
    						$geotagged = true;
    	                    foreach($this->supported_properties AS $prop_key) {
    	                        if (!isset($props[$prop_key])) {
    	                            $geotagged = false;
    	                        }
    	                    }
    	                    if ($geotagged) {
    		                    // Write the link
    		                    $msg = '<div class="serendipity_geotag">' . PLUGIN_EVENT_GEOTAG_FRONTEND_LABEL . ': %s</div>';
    		                    $link = "<a href=\"" . $this->get_config('map_url') . "\">%GEO_LAT%, %GEO_LONG%</a>";
    		                    $link = str_replace("%GEO_LAT%", $props["geo_lat"], $link);
    		                    $link = str_replace("%GEO_LONG%", $props["geo_long"], $link);
                                $replace_by = isset($eventData[$i]['title']) ? urlencode($eventData[$i]["title"]) : "GeoTag";
                                $link = str_replace("%TITLE%", $replace_by, $link);
    		                    if (!isset($eventData[$i]['add_footer'])) $eventData[$i]['add_footer'] = "";
                                $eventData[$i]['add_footer'] .= sprintf($msg, $link);
    	                    }
    	                    $i++;

                        }
                	}
                    return true;

                case 'frontend_display:rss-2.0:namespace':
                    $eventData['display_dat'] = 'xmlns:geo="http://www.w3.org/2003/01/geo/wgs84_pos#"';

                    return true;

                case 'frontend_display:rss-2.0:per_entry':
                    // Check if geo_lat and geo_long are both set
                    $props = &$eventData['properties'];
                    foreach($this->supported_properties AS $prop_key) {
                        if (!isset($props[$prop_key])) {
                            return true;
                        }
                    }
                    $eventData['display_dat'] = '<geo:long>' . $props["geo_long"] . '</geo:long>';
                    $eventData['display_dat'] .= '<geo:lat>' . $props["geo_lat"] . '</geo:lat>';

                    return true;

                default:
                    return false;
            }
        } else {
            return false;
        }
    }
}
